<template>
    <div>
        <div class="row">
            <div class="col-md-12 grid-margin stretch-card">
                <div class="card">
                    <div class="card-body">
                        <h3>Formulir Inovasi Daerah</h3>
                        <p>Silahkan membaca deskripsi atau keterangan terlebih dahulu dari masing-masing isian dalam formulir ini. Jika terdapat pertanyaan dan kesulitan, silahkan berkoordinasi ke Whatsapp Grup "Koordinasi IGA DPS 2020"</p>
                        <br>
                        <p style="color:red;"><a style="color:red;">*</a>Required</p>
                    </div>
                </div>
            </div>
            <div class="col-md-6 grid-margin stretch-card">
                <div class="card">
                  <div class="card-body">
                    <form class="forms-sample">
                        <!-- <div class="form-group">
                            <label for="exampleInputEmail1" >Email address <a style="color:red;"><a style="color:red;">*</a></a></label>
                            <input  type="email"
                                    class="form-control"
                                    id="exampleInputEmail1"
                                    placeholder="Email"
                                    v-model="currentData.email"
                                    v-validate="'required'"
                                    name="email"
                                    data-vv-as="Email">

                             <div class="text-danger small">{{ veeErrors.first('email') }}</div>
                        </div> -->
                        <div class="form-group">
                            <label for="nama_singkat">Nama Singkat Inovasi Daerah <a style="color:red;"><a style="color:red;">*</a></a></label>
                                <input  type="text"
                                    class="form-control"
                                    id="nama_singkat"
                                    autocomplete="off"
                                    placeholder="Your answer"
                                    v-model="currentData.nama_singkat"
                                    v-validate="'required'"
                                    name="nama_singkat"
                                    data-vv-as="Nama Singkat Inovasi Daerah">
                            <div class="text-danger small">{{ veeErrors.first('nama_singkat') }}</div>
                        </div>
                        <div class="form-group">
                            <label for="nama_lengkap">Nama Lengkap Inovasi Daerah <a style="color:red;"><a style="color:red;">*</a></a></label>
                                <input  type="text"
                                    class="form-control"
                                    id="nama_lengkap"
                                    autocomplete="off"
                                    placeholder="Your answer"
                                    v-model="currentData.nama_lengkap"
                                    v-validate="'required'"
                                    name="nama_lengkap"
                                    data-vv-as="Nama Lengkap Inovasi Daerah">
                            <div class="text-danger small">{{ veeErrors.first('nama_lengkap') }}</div>
                        </div>
                        <div class="form-group">
                            <label for="exampleFormControlSelect1">Nama OPD <a style="color:red;">*</a></label>
                            <select class="form-control"
                                    id="name_opd"
                                    v-model="currentData.name_opd"
                                    v-validate="'required'"
                                    name="name_opd"
                                    data-vv-as="Nama OPD">

                                <option selected disabled>Choose</option>
                                <option>12-18</option>
                                <option>18-22</option>
                                <option>22-30</option>
                                <option>30-60</option>
                                <option>Above 60</option>
                            </select>
                            <div class="text-danger small">{{ veeErrors.first('name_opd') }}</div>
                        </div>
                        <div class="form-group">
                            <label for="exampleFormControlSelect1">Tahapan Inovasi Daerah <a style="color:red;">*</a></label>
                            <div class="form-check" v-for="(tahapan_inovasi,index) in tahapaninovasi" :key="index">
                                <label class="form-check-label">
                                    <input  type="radio"
                                            class="form-check-input input-frame"
                                            id="tahapan_inovasi_id"
                                            :value="tahapan_inovasi.id"
                                            v-model="currentData.tahapan_inovasi_id"
                                            v-validate="'required'"
                                            name="tahapan_inovasi_id"
                                            data-vv-as="Tahapan Inovasi Daerah">
                                    {{ tahapan_inovasi.name }}
                                    <i class="input-frame"></i>
                                </label>
                            </div>
                            <div class="text-danger small">{{ veeErrors.first('tahapan_inovasi_id') }}</div>
                        </div>
                    </form>
                  </div>
                </div>
            </div>

            <div class="col-md-6 grid-margin stretch-card">
                <div class="card">
                  <div class="card-body">
                    <form class="forms-sample">
                        <div class="form-group">
                            <label for="exampleFormControlSelect1">Inisiator Inovasi Daerah <a style="color:red;">*</a></label>
                            <div class="form-check" v-for="(inisiator_inovasi,index) in inisiatorinovasi" :key="index">
                                <label class="form-check-label">
                                    <input  type="radio"
                                            class="form-check-input"
                                            id="inisiator_inovasi_id"
                                            :value="inisiator_inovasi.id"
                                            v-model="currentData.inisiator_inovasi_id"
                                            v-validate="'required'"
                                            name="inisiator_inovasi_id"
                                            data-vv-as="Inisiator Inovasi Daerah">
                                    {{ inisiator_inovasi.name }}
                                    <i class="input-frame"></i>
                                </label>
                            </div>
                            <div class="text-danger small">{{ veeErrors.first('inisiator_inovasi_id') }}</div>
                        </div>
                        <div class="form-group">
                            <label for="exampleFormControlSelect1">Jenis Inovasi Daerah <a style="color:red;">*</a></label>
                            <div class="form-check" v-for="(jenis_inovasi,index) in jenisinovasi" :key="index">
                                <label class="form-check-label">
                                    <input  type="radio"
                                            class="form-check-input"
                                            id="jenis_inovasi_id"
                                            :value="jenis_inovasi.id"
                                            v-model="currentData.jenis_inovasi_id"
                                            v-validate="'required'"
                                            name="jenis_inovasi_id"
                                            data-vv-as="Jenis Inovasi Daerah">
                                    {{ jenis_inovasi.name }}
                                    <i class="input-frame"></i>
                                </label>
                            </div>
                            <div class="text-danger small">{{ veeErrors.first('jenis_inovasi_id') }}</div>
                        </div>
                        <div class="form-group">
                            <label for="exampleFormControlSelect1">Bentuk Inovasi Daerah <a style="color:red;">*</a></label>
                            <div class="form-check" v-for="(bentuk_inovasi,index) in bentukinovasi" :key="index">
                                <label class="form-check-label">
                                    <input  type="radio"
                                            class="form-check-input"
                                            id="bentuk_inovasi_id"
                                            :value="bentuk_inovasi.id"
                                            v-model="currentData.bentuk_inovasi_id"
                                            v-validate="'required'"
                                            name="bentuk_inovasi_id"
                                            data-vv-as="Bentuk Inovasi Daerah">
                                    {{ bentuk_inovasi.name }}
                                    <i class="input-frame"></i>
                                </label>
                            </div>
                            <div class="text-danger small">{{ veeErrors.first('bentuk_inovasi_id') }}</div>
                        </div>
                    </form>
                  </div>
                </div>
            </div>

            <div class="col-md-6 grid-margin stretch-card">
                <div class="card">
                  <div class="card-body">
                    <form class="forms-sample">
                        <div class="form-group">
                            <label for="exampleFormControlSelect1">Inovasi Daerah dalam rangka atau berkaitan dengan COVID-19 <a style="color:red;">*</a></label>
                            <div class="form-check" v-for="(covid_inovasi,index) in covidinovasi" :key="index">
                                <label class="form-check-label">
                                    <input  type="radio"
                                            class="form-check-input"
                                            id="covid_inovasi_id"
                                            :value="covid_inovasi.id"
                                            v-model="currentData.covid_inovasi_id"
                                            v-validate="'required'"
                                            name="covid_inovasi_id"
                                            data-vv-as="Inovasi Daerah dalam rangka atau berkaitan dengan COVID-19">
                                    {{ covid_inovasi.name }}
                                    <i class="input-frame"></i>
                                </label>
                            </div>
                            <div class="text-danger small">{{ veeErrors.first('covid_inovasi_id') }}</div>
                        </div>
                        <div class="form-group">
                            <label for="exampleFormControlSelect1">Waktu Uji Coba Inovasi Daerah</label>
                            <input  type="date"
                                class="form-control"
                                id="tgl_uji"
                                v-model="currentData.tgl_uji"
                                v-validate="'required'"
                                name="tgl_uji"
                                data-vv-as="Waktu Uji Coba Inovasi Daerah">
                                <div class="text-danger small">{{ veeErrors.first('tgl_uji') }}</div>
                        </div>
                        <div class="form-group">
                            <label for="exampleFormControlSelect1">Waktu Implementasi Inovasi Daerah</label>
                            <input  type="date"
                                class="form-control"
                                id="tgl_implementasi"
                                v-model="currentData.tgl_implementasi"
                                v-validate="'required'"
                                name="tgl_implementasi"
                                data-vv-as="Waktu Implementasi Inovasi Daerah">
                                <div class="text-danger small">{{ veeErrors.first('tgl_implementasi') }}</div>
                        </div>
                        <div class="form-group">
                            <label for="exampleInputUsername1">Rancang Bangun dan Pokok Perubahan yang Dilakukan <a style="color:red;"><a style="color:red;">*</a></a></label>
                            <input  type="text"
                                    class="form-control"
                                    id="rencana_bangun"
                                    autocomplete="off"
                                    placeholder="Your answer"
                                    v-model="currentData.rencana_bangun"
                                    v-validate="'required'"
                                    name="rencana_bangun"
                                    data-vv-as="Rancang Bangun dan Pokok Perubahan yang Dilakukan">
                            <div class="text-danger small">{{ veeErrors.first('rencana_bangun') }}</div>
                        </div>
                    </form>
                  </div>
                </div>
            </div>

            <div class="col-md-6 grid-margin stretch-card">
                <div class="card">
                  <div class="card-body">
                    <form class="forms-sample">
                        <div class="form-group">
                            <label for="exampleInputUsername1">Manfaat yang Diperoleh dari Inovasi Daerah Tersebut <a style="color:red;"><a style="color:red;">*</a></a></label>
                            <input  type="text"
                                class="form-control"
                                id="manfaat_inovasi"
                                autocomplete="off"
                                placeholder="Your answer"
                                v-model="currentData.manfaat_inovasi"
                                v-validate="'required'"
                                name="manfaat_inovasi"
                                data-vv-as="Manfaat yang Diperoleh dari Inovasi Daerah Tersebut">
                            <div class="text-danger small">{{ veeErrors.first('manfaat_inovasi') }}</div>
                        </div>
                        <div class="form-group">
                            <label for="exampleInputUsername1">Rancang Bangun dan Pokok Perubahan yang Dilakukan <a style="color:red;"><a style="color:red;">*</a></a></label>
                            <input  type="text"
                                class="form-control"
                                id="hasil_inovasi"
                                autocomplete="off"
                                placeholder="Your answer"
                                v-model="currentData.hasil_inovasi"
                                v-validate="'required'"
                                name="hasil_inovasi"
                                data-vv-as="Rancang Bangun dan Pokok Perubahan yang Dilakukan">
                            <div class="text-danger small">{{ veeErrors.first('hasil_inovasi') }}</div>
                        </div>
                        <div class="form-group">
                            <label>Anggaran (Jika tersedia)</label>
                            <p style="font-size:12px; text-align: justify;">Kebutuhan data pendukung adalah file persentasi (ppt)</p>
                            <div v-for="(file, index) in anggaran_file" :key="index">
                              <img v-if="!file.error" :src="getFile(file.name)" alt="Anggaran" width="100" height="auto" >
                              <span v-else>Can't Preview File</span>
                                  <br/>
                              <span>File: {{file.name}}</span> |
                              <span>Size: {{file.size | formatSize}}</span>|
                              <span v-if="file.error" class="btn-danger pl-1 pr-1">{{(file.error=='denied'?"Upload File Failed":"Upload File Error")}}</span>
                              <span v-else-if="file.success"  class="btn-success pl-1 pr-1">Success Upload</span>
                              <span v-else-if="file.active">Proses Upload - {{file.progress}}/100</span>
                              <span v-else></span>
                              <div :class="{'progress-bar': true, 'progress-bar-striped': true, 'bg-danger': file.error, 'progress-bar-animated': file.active}" role="progressbar" :style="{width: file.progress + '%'}">{{file.progress}}%</div>
                            </div>
                            <file-upload
                                class="btn btn-primary"
                                post-action="/upload/anggaran_file"
                                extensions="ppt,pptx"
                                accept="application/vnd.ms-powerpoint,application/vnd.openxmlformats-officedocument.presentationml.presentation"
                                :multiple="false"
                                v-model="anggaran_file"
                                @input-filter="inputFilter"
                                @input-file="uploadAnggaranFile"
                                ref="anggaran_file"
                                :headers="{'X-CSRF-TOKEN': token}"
                                :drop="true"
                                name="anggaran_file"
                                data-vv-as="Upload File"
                                v-validate="'required'">
                                <i class="fa fa-plus"></i>
                                Select files
                            </file-upload>
                            <div class="text-danger small">{{ veeErrors.first('anggaran_file') }}</div>
                        </div>

                        <div class="form-group">
                            <label>Proses Bisnis (Jika tersedia)</label>
                            <p style="font-size:12px; text-align: justify;">Kebutuhan data pendukung adalah file persentasi (ppt)</p>
                            <div v-for="(file, index) in  prosesbisnis_file" :key="index">
                              <img v-if="!file.error" :src="getFile(file.name)" alt="Proses Bisnis" width="100" height="auto" >
                              <span v-else>Can't Preview File</span>
                                  <br/>
                              <span>File: {{file.name}}</span> |
                              <span>Size: {{file.size | formatSize}}</span>|
                              <span v-if="file.error" class="btn-danger pl-1 pr-1">{{(file.error=='denied'?"Upload File Failed":"Upload File Error")}}</span>
                              <span v-else-if="file.success"  class="btn-success pl-1 pr-1">Success Upload</span>
                              <span v-else-if="file.active">Proses Upload - {{file.progress}}/100</span>
                              <span v-else></span>
                              <div :class="{'progress-bar': true, 'progress-bar-striped': true, 'bg-danger': file.error, 'progress-bar-animated': file.active}" role="progressbar" :style="{width: file.progress + '%'}">{{file.progress}}%</div>
                            </div>

                            <file-upload
                                class="btn btn-primary"
                                post-action="/upload/prosesbisnis_file"
                                extensions="ppt,pptx"
                                accept="application/vnd.ms-powerpoint,application/vnd.openxmlformats-officedocument.presentationml.presentation"
                                :multiple="false"
                                v-model="prosesbisnis_file"
                                @input-filter="inputFilter"
                                @input-file="uploadProsesBisnisFile"
                                ref="prosesbisnis_file"
                                :headers="{'X-CSRF-TOKEN': token}"
                                :drop="true"
                                name="prosesbisnis_file"
                                data-vv-as="Upload File"
                                v-validate="'required'">
                                <i class="fa fa-plus"></i>
                                Select files
                            </file-upload>
                            <div class="text-danger small">{{ veeErrors.first('prosesbisnis_file') }}</div>
                        </div>
                    </form>
                  </div>
                </div>
            </div>
        </div>
        <button class="btn btn-primary" type="submit" @click.prevent="submit()">Submit form</button>
    </div>
</template>

<script>

    export default {
        props: ['dataprops'],
        filters: {
        formatSize: function (value) {
            if (!value) return ''
                let valKB = 0.000001*value
                return `${valKB.toFixed(2)} MB`
            }
        },

        //Binding Data
        data() {
            return {
                component:'Page1Component',
                token:document.head.querySelector('meta[name="csrf-token"]').content,
                currentData:{
                    id:'',
                    email:'',
                    name:'',
                    name_opd:'',
                    tahapan_inovasi_id:'',
                    inisiator_inovasi_id:'',
                    jenis_inovasi_id:'',
                    bentuk_inovasi_id:'',
                    covid_inovasi_id:'',
                    tgl_uji:'',
                    tgl_implementasi:'',
                    rencana_bangun:'',
                    manfaat_inovasi:'',
                    hasil_inovasi:'',
                    anggaran_file:'',
                    prosesbisnis_file:'',
                },

                //initializing property form
                tahapan_inovasi_id:[],
                inisiator_inovasi_id :[],
                jenis_inovasi_id :[],
                bentuk_inovasi_id :[],
                covid_inovasi_id :[],

                //initializing property funtion get data
                tahapaninovasi:[],
                inisiatorinovasi:[],
                jenisinovasi:[],
                bentukinovasi:[],
                covidinovasi:[],

                //initializing property upload file
                // files: [],
                prosesbisnis_file: [],
                anggaran_file: [],
                image_folder:"iconFile"

            }
        },

        created(){
            // this.initial();
            this.getTahapanInovasi();
            this.getInisiatorInovasi();
            this.getJenisInovasi();
            this.getBentukInovasi();
            this.getCovidInovasi();
            // this.testData();
        },

        methods: {
            // initial(){
            //     this.currentData.id = this.dataprops.id
            // },
            testData(){
                this.currentData = {
                    email:'test@gmail.com',
                    name:'Edi',
                    name_opd:'18-22',
                    tahapan_inovasi_id:3,
                    inisiator_inovasi_id:2,
                    jenis_inovasi_id:2,
                    bentuk_inovasi_id:2,
                    covid_inovasi_id:2,
                    tgl_uji:'2021-03-25',
                    tgl_implementasi:'2021-03-25',
                    rencana_bangun:'test',
                    manfaat_inovasi:'test',
                    hasil_inovasi:'test',
                    anggaran_file:'test',
                    prosesbisnis_file:'test',
                }
            },

            //function to get all data from laravel route (Frontend/Home)
            getTahapanInovasi() {
                axios.get('/form1/get/tahapaninovasi').then(response => {
                   this.tahapaninovasi = response.data
                })
            },
            getInisiatorInovasi() {
                axios.get('/form1/get/inisiatorinovasi').then(response => {
                   this.inisiatorinovasi = response.data
                })
            },
            getJenisInovasi() {
                axios.get('/form1/get/jenisinovasi').then(response => {
                   this.jenisinovasi = response.data
                })
            },
            getBentukInovasi() {
                axios.get('/form1/get/bentukinovasi').then(response => {
                   this.bentukinovasi = response.data
                })
            },
            getCovidInovasi() {
                axios.get('/form1/get/covidinovasi').then(response => {
                   this.covidinovasi = response.data
                })
            },

            //function when user click the button submit
            submit(){
                //checking validation form
                this.$validator.validate().then(valid => {
                    if (valid) {
                        //Insert data to backend(laravel)
                        this.insertData()
                        //to next component
                        this.toNextComponent('Page2Component')
                    }
                 });
            },

            formData(obj){
                var formData = new FormData();
                for (var key in obj) {
                    formData.append(key, obj[key]);
                }
                return formData;
            },

            //function send data to backend (/form1/send) and get the the current Id
            async insertData(){
                // let self = this
                this.currentData.anggaran_file =`${this.anggaran_file[0].postAction}/${this.anggaran_file[0].name}`
                this.currentData.prosesbisnis_file =`${this.prosesbisnis_file[0].postAction}/${this.prosesbisnis_file[0].name}`
                let data = this.formData(this.currentData)
                await axios.post('/form1/send',data).then(response => {
                   this.currentData.id = response.data
                })
            },

            //function send to next component
            toNextComponent(visit){
                let data = {
                    back:this.component,
                    data:this.currentData,
                    visit
                }
                this.$emit('datacomponent', data)

            },

            //function for inputfilter file from Plugin
            inputFilter(newFile, oldFile, prevent) {
              if (newFile && !oldFile) {
                if (/(\/|^)(Thumbs\.db|desktop\.ini|\..+)$/.test(newFile.name)) {
                  return prevent()
                }
                if (/\.(php5?|html?|jsx?)$/i.test(newFile.name)) {
                  return prevent()
                }
              }
            },

            //function for activing upload file when user upload the file
            uploadAnggaranFile() {
                this.$refs.anggaran_file.active = true
            },
            uploadProsesBisnisFile() {
                this.$refs.prosesbisnis_file.active = true
            },


            getFile(link){
              return `${this.image_folder}/file.png`
            },
        },
    }
</script>

<style>

</style>
